var map;
var largeMapCtl;
var scaleCtl;
var mapTypeCtl;

function getnewMap() {
	map = new GMap2(document.getElementById("map")	);
	return map;
}

function createMarker(point, descrip) {
  var marker = new GMarker(point);
  GEvent.addListener(marker, "click", function() {
    marker.openInfoWindowHtml(descrip);
  });
  return marker;
}

function set_gmap_latlong(instring) {
  var splitstring=instring.split(",");
  map.panTo(new GLatLng(splitstring[0],splitstring[1]));
}


function get_gmap_latlong(map) {
  return map.getCenter().toString();
}


function setmapthingZoom(invalue) {
  map.setZoom(parseInt(invalue));
}

function setlargemapctl(invalue) {
 if (invalue) {
 	if ( largeMapCtl == null ) {
 	 largeMapCtl = new GLargeMapControl();
 	}
	map.addControl(largeMapCtl);
 } else {
	map.removeControl(largeMapCtl);
 }
}

function setscalectl(invalue) {
 if (invalue) {
 	if ( scaleCtl == null ) {
 	 scaleCtl = new GScaleControl();
 	}
	map.addControl(scaleCtl);
 } else {
	map.removeControl(scaleCtl);
 }

}

function setmaptypectl(invalue) {
 if (invalue) {
 	if ( mapTypeCtl == null ) {
 	 mapTypeCtl = new GMapTypeControl();
 	}
	map.addControl(mapTypeCtl);
 } else {
	map.removeControl(mapTypeCtl);
 }

}
 
 
function setMapCenter(doc, pnt) {
//    doc.getElementById("message").innerHTML = pnt.toString());
}


function addContactToMap(lat, lng, info)  {
		var point = new GLatLng(lat, lng);
		var marker = createMarker(point, info);
		map.addOverlay(marker);
}

function setMapContacts(uri, groupname) {

 	HTTPGet(uri+"/"+groupname, addContactsToMap, "") ;
 
}


function addContactsToMap(httpresponse, xmlhttp, contacts) {
  if (xmlhttp.status != 200) {
    alert('An HTTP error '+ xmlhttp.status +' occured.\n'+ httpresponse);	
  }  ;
    map.clearOverlays();
    var parsed = patchedParseJson(httpresponse);
    for ( x in parsed ) {
       addContactToMap(parsed[x][0], parsed[x][1], parsed[x][2]);
    }
}


function patchedParseJson(data) {
 if ((data.substring(0, 1) != '{') && (data.substring(0, 1) != '[')) {
    return { status: 0, data: data.length ? data : 'Unspecified error' };
  }
  return eval('(' + data + ');');
}