<?php


// TO DO - this code is from the gmap module and get's location info from the location table
//
//        $res=db_query("SELECT * FROM {location} WHERE oid=%d AND type='user'",$user->uid);
//        if ($gmap_user=db_fetch_array($res)) {
//          $user->latitude=$gmap_user['latitude'];
//          $user->longitude=$gmap_user['longitude'];
//          $user->location=TRUE;
//        }


function getContactLatitude($contact_UF_ID) {
 
	$contact = _getContact($contact_UF_ID);
	return $contact['geo_code_1'];

}


function getContactLongitude($contact_UF_ID) {
	$contact = _getContact($contact_UF_ID);
	return $contact['geo_code_2'];
}

function setContactLatitude($contact_UF_ID, $lat) {

	civicrm_initialize( true );
	
  	$params = array( 'id' => crm_uf_get_match_id($contact_UF_ID));
	$contact = crm_get_contact( $params );
    $locations = crm_get_locations($contact);
    $params = array('geo_code_1'=>$lat);
	$locations = crm_update_location($contact, 'Home', $params);

}


function _getContact($contact_UF_ID) {

 static $contacts;
 static $civicrmID;

 if ( $contacts == NULL ) {
        civicrm_initialize( true );    
 	    $civicrmID = crm_uf_get_match_id($contact_UF_ID);
  		$params = array( 'id' => $civicrmID );
        $contacts = crm_contact_search( $params );
//        CRM_Core_Error::debug( 'contacts', $contacts );
 }
 	return $contacts[0][$civicrmID];

}


function getGroupNames() { 

	civicrm_initialize( true );
	$groups =& crm_get_groups();
	$x = count($groups);
	$i = 0;
	$j = 0;

 	while ($i < $x ) {
    	$groupNames[$groups[$i]->name]= $groups[$i]->name; 
    	$i++;
 	}

    return $groupNames;
}


function getContactsInGroup(&$groupname) {

    if ( ( $groupname == '' ) or ( $groupname == NULL ) ) {
       return NULL;
    };

    civicrm_initialize( true );    

	$params = array('name' => $groupname);
    $groups =& crm_get_groups($params);
	$return_properties = array('geo_code_1', 'geo_code_2', 'display_name');
    $contacts = crm_get_group_contacts($groups[0], $return_properties, 'Added', null, 0, 25 )  ;
	return $contacts;
}
